<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2010 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Blocks
 */
/**************************************************************************/

/**
 * Блок "Список коментариев".
 *
 * <a href="http://wiki.a-cms.ru/blocks/comments">Руководство</a>.
 */

class comments_Block extends A_Block
{
/**
 * Формирование данных доступных в шаблоне.
 */

  function createData()
  {
	$this->supportCached(true);

    $comments=array();
	if($idsections=!empty($this->params['idsections'])?$this->params['idsections']:array())
	{
	  foreach($idsections as $i=>$idsec)
	  $idsections[$i]=(integer)$idsec;

	  $sections=A::$DB->getAssoc("SELECT s.id AS ids,s.* FROM ".DOMAIN."_sections AS s WHERE s.id IN(".implode(',',$idsections).")");

	  A::$DB->queryLimit("SELECT * FROM ".DOMAIN."_comments WHERE idsec IN(".implode(',',$idsections).") AND active='Y' ORDER BY date DESC",0,$this->params['rows']);
	  while($row=A::$DB->fetchRow())
	  { if(isset($sections[$row['idsec']]))
		{ $section=DOMAIN.'_'.$sections[$row['idsec']]['lang'].'_'.$sections[$row['idsec']]['name'];
		  switch($sections[$row['idsec']]['module'])
		  { case 'guestbook':
		      $row['item']=$sections[$row['idsec']]['caption_'.LANG];
		      $row['link']=getSectionLink($section);
		      break;
		    case 'catalog':
		      if($irow=A::$DB->getRow("SELECT idcat,name,urlname FROM {$section}_catalog WHERE id=".$row['iditem']))
              { $row['item']=$irow['name'];
		        $row['link']=catalog_createCategoryLink($irow['idcat'],$section).$irow['urlname'].".html";
		      }
		      break;
		    case 'gallery':
		      if($irow=A::$DB->getRow("SELECT idcat,name,urlname FROM {$section}_albums WHERE id=".$row['iditem']))
              { $row['item']=$irow['name'];
		        $row['link']=gallery_createCategoryLink($irow['idcat'],$section).$irow['urlname'].".html";
		      }
		      break;
		    case 'shoplite':
		      if($irow=A::$DB->getRow("SELECT idcat,name,urlname FROM {$section}_catalog WHERE id=".$row['iditem']))
              { $row['item']=$irow['name'];
		        $row['link']=shoplite_createCategoryLink($irow['idcat'],$section).$irow['urlname'].".html";
		      }
		      break;
          }
		}

		if($row['iduser']>0 && A::$AUTH->section)
	    { if($row['user']=A::$DB->getRowById($row['iduser'],A::$AUTH->section))
	      prepareValues(A::$AUTH->section,$row['user']);
	    }

	    $comments[]=$row;
	  }
	  A::$DB->free();

	  $this->Assign("comments",$comments);
	}
  }
}